# fate\_extensions

* Adds new operations to the FATE VM (version 3)
  * bitwise operations on integers (`band`, `bor`, `bxor`, `bnot`, `<<` and `>>`)
  * Address.to\_bytes - converting an address to its binary representation
  * Int.mulmod - a combined multiplication and modulus operation for efficiency
  * Crypto.poseidon - a ZK/SNARK friendly hash function
  * Introduce arbitrary sized binary arrays (type `bytes()`); adding `Bytes.split_any`,`Bytes.to_fixed_size`, `Bytes.to_any_size`, `Bytes.size`, `String.to_bytes`,\
    and `Int.to_bytes`; and adjust `Bytes.concat`, and `Crypto.verify_sig` to allow both\
    fixed and arbitrary sized byte arrays.
  * Chain.network\_id - the network id of the chain


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.aeternity.com/developer-documentation/aeternity/docs/release-notes/next-ceres/fate_extensions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
